//+------------------------------------------------------------------+
//|                                                        _BOLL.mq4 |
//|                                                       iPlayGames |
//|                                               http://www.iPG.net |
//+------------------------------------------------------------------+
//*
//* _BOLL
//*
//* 2006/12/13 version 4.4
//* 2006/07/01 initial version 1.0
//* 
#property copyright "iPlayGames"
#property link "http://www.iPG.net"

#include <cglib.mq4> //custom dll function by Codersguru @ http://www.metatrader.info/node/89

//---- optimization parameters
   extern bool ReduceRisk = False;
   extern bool LotsControl = True;
   extern int CapitalPerLot = 20000;
   extern int BOLL = 5;
   extern int StopLoss = 20;
   extern int TakeProfit = 1000;
   extern int BreakEven = 0;
   extern int TrailingStop = 0;
   extern bool Skype = False;
   extern bool Rasdial = False;
   extern bool MailAlert = False;
   extern bool TradeLog = True;
   bool ShowAccInfo = True;
   bool NewHLAlert = False;
   bool ExitNow = False;
//---- globals
   int step = 4;
   int timeout = 9;
   int Slippage = 9;
   int precision = 4;
   int magic_base = 1000;
   int orderinterval = 9000;
   bool TestMode = False;
   string comment = "";
   datetime expiration = 0;
 //---- colors
   int clr_close = Blue;
   int clr_modify = Black;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
 //----
    comment = "myBOLL_"+Symbol()+"_"+BOLL;
    magic_base = 1000 + BOLL;
    step = MarketInfo(Symbol(),MODE_STOPLEVEL);
    precision = MarketInfo(Symbol(),MODE_DIGITS);
 //----
    if(ShowAccInfo==True){
   //----   
      Print("AccountName is "+AccountName()+"; AccountNumber is "+AccountNumber()+"; AccountLeverage is "+AccountLeverage());
      Print(Symbol()+"; Spread = "+MarketInfo(Symbol(),MODE_SPREAD)+"; Stop.Level = "+MarketInfo(Symbol(),MODE_STOPLEVEL)+"; Point.Size = "+MarketInfo(Symbol(),MODE_POINT)+"; Tick.Value = "+MarketInfo(Symbol(),MODE_TICKVALUE));
      Print(Symbol()+"; Min.Lot = "+MarketInfo(Symbol(),MODE_MINLOT)+"; Max.Lot = "+MarketInfo(Symbol(),MODE_MAXLOT)+"; Lot.Step = "+MarketInfo(Symbol(),MODE_LOTSTEP));
      Print(Symbol()+"; Swap.Long = "+MarketInfo(Symbol(),MODE_SWAPLONG)+"; Swap.Short = "+MarketInfo(Symbol(),MODE_SWAPSHORT)+"; Swap.Type = "+MarketInfo(Symbol(),MODE_SWAPTYPE));
      Print(Symbol()+"; Margin for 1 Lot: Initial = "+MarketInfo(Symbol(),MODE_MARGININIT)+", Mainten = "+MarketInfo(Symbol(),MODE_MARGINMAINTENANCE)+"; Hedge = "+MarketInfo(Symbol(),MODE_MARGINHEDGED)+"; Required = "+MarketInfo(Symbol(),MODE_MARGINREQUIRED));
   //----   
      if(AccountStopoutMode()==0) Print("StopOut level = ", AccountStopoutLevel(), "%");
      else Print("StopOut level = ", AccountStopoutLevel(), " ", AccountCurrency());
   //----
    }
 //----   
    return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
 //----
 //----
    return(0);
  }
//+------------------------------------------------------------------+
//| New Bar                                                          |
//+------------------------------------------------------------------+
bool NewBar()
  {
 //----
    static datetime lastbar = 0;
    datetime curbar = Time[0];
    if(lastbar!=curbar){
      lastbar = curbar;
      return(True);
    }
    else return(False);
 //----
  }
//+------------------------------------------------------------------+
//| Log the Trades                                                   |
//+------------------------------------------------------------------+
void Trade_Log(string type,string price,string sigBar)
  {
//----
   string log = type+"@"+price+" @ "+sigBar+" Bars"+" @ "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES);
   int handle = FileOpen("BOLL_"+BOLL+"_"+Symbol()+"_"+Period()+"_lastTrade.dat",FILE_BIN|FILE_READ|FILE_WRITE);
   if(handle>0){ FileWrite(handle,log);
                 FileClose(handle);
                 handle = 0;
   }
   else Print("FileOpen returned the error of ",GetLastError());
//----
  }
//+------------------------------------------------------------------+
//| expert specific function GetOpenSignal()                         |
//+------------------------------------------------------------------+
int CheckSignal(string type,string price,string sigBar)
  {
 //----local variables
    int handle =0;
    bool GoLongNow = False;
    bool GoShortNow = False;   
    bool ForbidLong = False;
    bool ForbidShort = False;
    string lastTrade = "";
    string lastType = "";
    string lastPrice = "";
    string lastSigBar = "";
 //---- read the last entry record by the expert;
    handle = FileOpen("BOLL_"+BOLL+"_"+Symbol()+"_"+Period()+"_lastTrade.dat",FILE_BIN|FILE_READ|FILE_WRITE);
    if(handle>0){ lastTrade = FileReadString(handle,22);
                  lastType = StringSubstr(lastTrade,0,5);
                  lastPrice = StringSubstr(lastTrade,6,6);
                  lastSigBar = StringSubstr(lastTrade,15,7);
                  FileClose(handle);
                  handle = 0;
    }
    else Print("FileOpen returned the error of ",GetLastError());
 //---- compare the last indicator record with the last expert record
    if(StrToInteger(sigBar)>StrToInteger(lastSigBar)){
      if(type=="long "){ GoLongNow = True; 
                         GoShortNow = False;
      }
      if(type=="short"){ GoLongNow = False;
                         GoShortNow = True;
      }
    }
    else if(lastType=="long "){ ForbidLong = True;
                                ForbidShort = False;
    }
    else if(lastType=="short"){ ForbidLong = False;
                                ForbidShort = True;
    }
 //---- check whether or not it's ok to go long
    if((GoLongNow==True && ForbidLong==False) || (GoShortNow==True && ForbidShort==False)){
      return(1);
    }
 //---- send signal to do nothing
    return(0);
  }
//+------------------------------------------------------------------+
//| expert specific function ModifyStatus()                          |
//+------------------------------------------------------------------+
int ModifyStatus(string type,string price)
{
//----
   string TimeNow = TimeToStr(TimeCurrent(),TIME_MINUTES);
//----
   if(type=="long "){
  //---- delete existing short pending orders;
     DeletePending("short");
  //---- if True, close existing short position, otherwise move SL;
     if(ExitNow==True) ClosePositions("short");
     else ModifySL("short",StrToDouble(price));
  //---- run Skype.bat to dial my mobile phone
     if(Skype==True) Shell("C:\\Apps\\Skype.bat","");
  //---- run Rasdial.bat to dial my mobile phone
     if(Rasdial==True) Shell("C:\\Apps\\Rasdial.bat","");
  //---- send email alert  
     if(MailAlert==True) SendMail("BOLL_"+Symbol()+" BS@"+price+"; "+TimeNow," ");
  //----
     return(0);
   }
//----
   if(type=="short"){
  //---- delete existing long pending orders;
     DeletePending("long ");
  //---- if True, close existing long position, otherwise move SL;
     if(ExitNow==True) ClosePositions("long ");
     else ModifySL("long ",StrToDouble(price));
  //---- run Skype.bat to dial my mobile phone
     if(Skype==True) Shell("C:\\Apps\\Skype.bat","");
  //---- run Rasdial.bat to dial my mobile phone
     if(Rasdial==True) Shell("C:\\Apps\\Rasdial.bat","");
  //---- send email alert  
     if(MailAlert==True) SendMail("BOLL_"+Symbol()+" SS@"+price+"; "+TimeNow," ");
  //----
     return(0);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert CheckOrders function                                      |
//+------------------------------------------------------------------+
int CheckOrders()
{
//----
   int i,res,pending,tries;
   int tickets[99];
//----
   int ticket = 0;
   int total = OrdersTotal();
//----   
   for(i=total;i>=0;i--) tickets[i] = 0;
//----   
   for(i=total;i>=0;i--){
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
       //Print("order_",OrderTicket()," Magic = ",OrderMagicNumber());
       if(OrderMagicNumber()==magic_base && OrderType()>1){
         pending++;
         tickets[i] = OrderTicket();
       }
     }
     //else Print("OrderSelect returned the error of ",GetLastError());     
   }
   while(pending>1){
     for(i=total;i>=0;i--){
       if(tickets[i]>0) ticket = tickets[i];
       if(tickets[i]>0 && tickets[i]<ticket) ticket = tickets[i];
     }
     tries = 0;
     if(ticket>0){
       while(tries<timeout){
         res = OrderDelete(ticket);
         if(res>0){
           tries = timeout;
           Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Pending Order_"+ticket+" Deleted!");
         }
         else{ tries++;
               Print("OrderDelete returned the error of ",GetLastError());
               Sleep(orderinterval);
         }
       }
     }
     pending--;
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert CheckStopLoss function                                    |
//+------------------------------------------------------------------+
int CheckSL()
{
//----
   int i,ticket,tries;
   double SL = 0.0;
   int total = OrdersTotal();
//----
   for(i=total;i>=0;i--){
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
       if(OrderType()==OP_BUY && OrderMagicNumber()==magic_base){
         SL = NormalizeDouble(OrderOpenPrice()-StopLoss*Point,precision);
         if(OrderStopLoss()<SL){
           ticket = OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,clr_modify);
           tries = 0;
           while(tries<timeout){
             if(ticket>0){
               tries = timeout;
               Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Buy Order_"+ticket+" SL modified!");
             }
             else{ tries++;
                   Print("OrderModify returned the error of ",GetLastError());
                   Sleep(orderinterval);
             }
           }
         }
       }
    //----
       if(OrderType()==OP_SELL && OrderMagicNumber()==magic_base){
         SL = NormalizeDouble(OrderOpenPrice()+StopLoss*Point,precision);
         if(OrderStopLoss()>SL){
           ticket = OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,clr_modify);
           tries = 0;
           while(tries<timeout){
             if(ticket>0){
               tries = timeout;
               Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Sell Order_"+ticket+" SL modified!");
             }
             else{ tries++;
                   Print("OrderModify returned the error of ",GetLastError());
                   Sleep(orderinterval);
             }
           }
         }
       }
     }
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    int action,clr_entry,handle,method,tries;
    bool ticket = False;
    double SL = 0.0;
    double TP = 0.0;
    double Lots = 0.0;
    double newEntry = 0.0;
    string lastSignal = "";
    string lastType = "";
    string lastPrice = "";
    string lastSigBar = "";
    string lastRec = "";
    string lastSL = "";
    string lastSLBar = "";
 //----
    if(Bars<BOLL){ Alert("too few Bars!");
                 return(0);
    }
 //---- read the last entry record by the indicator;
    handle = FileOpen("BOLL_"+BOLL+"_"+Symbol()+"_"+Period()+"_lastSignal.dat",FILE_BIN|FILE_READ|FILE_WRITE);
    if(handle>0){ lastSignal = FileReadString(handle,22);
                  lastType = StringSubstr(lastSignal,0,5);
                  lastPrice = StringSubstr(lastSignal,6,6);
                  lastSigBar = StringSubstr(lastSignal,15,7);
                  FileClose(handle);
                  handle = 0;
    }
    else Print("FileOpen returned the error of ",GetLastError());
 //---- 
    if(ReduceRisk==True){
      handle = FileOpen("BOLL_"+BOLL+"_"+Symbol()+"_"+Period()+"_lastSL.dat",FILE_BIN|FILE_READ|FILE_WRITE);
      if(handle>0){ lastRec = FileReadString(handle,22);
                    lastSL = StringSubstr(lastRec,6,6);
                    lastSLBar = StringSubstr(lastRec,15,7);
                    FileClose(handle);
                    handle = 0;
      }
      else Print("FileOpen returned the error of ",GetLastError());
   //----
      if(StrToInteger(lastSLBar)>StrToInteger(lastSigBar)) ModifySL(lastType,StrToDouble(lastSL));
      //Print("lastSLBar = ",lastSLBar," lastSigBar = ",lastSigBar," lastSL = ",lastSL);
    } 
 //----
    RefreshRates();
 //---- make sure that any EA can only have one pending order in the pool at any one time
    CheckOrders();
 //----
    if(BreakEven>0) ModifyBE(lastType);
    if(TrailingStop>0) ModifyTS(lastType);
 //----
    if(LotsControl==True) Lots = SetLots();
    else Lots = NormalizeDouble(AccountBalance()/CapitalPerLot,1);
 //----
    if(Lots<0.1){ Alert("too little funds!");
                  return(0);
    }
 //----
    if(lastSignal!=""){
      action = CheckSignal(lastType,lastPrice,lastSigBar);
    }
    else return(0);
 //----
    if(action==0) return(0);
 //----
    if(action==1){
   //----
      ModifyStatus(lastType,lastPrice);
      newEntry = StrToDouble(lastPrice); 
   //---- 
      if(lastType=="long "){
        clr_entry = Green;
        if(newEntry>Ask+step*Point) method = OP_BUYSTOP;
        else if(newEntry<Bid) method = OP_BUYLIMIT;
        else{ method = OP_BUY;
              newEntry = NormalizeDouble(Ask,precision);
        }
     //----
        if(StopLoss>0) SL = newEntry - StopLoss*Point;
        else SL = 0.0;
     //----
        if(TakeProfit>0) TP = newEntry + TakeProfit*Point;
        else TP = 0.0;
      }
   //----
      if(lastType=="short"){
        clr_entry = Red;
        if(newEntry<Bid-step*Point) method = OP_SELLSTOP;
        else if(newEntry>Ask) method = OP_SELLLIMIT;
        else{ method = OP_SELL;
              newEntry = NormalizeDouble(Bid,precision); 
        }
     //----   
        if(StopLoss>0) SL = newEntry + StopLoss*Point;
        else SL = 0.0;
     //----
        if(TakeProfit>0) TP = newEntry - TakeProfit*Point;
        else TP = 0.0;
      }
   //----
      //while(IsTradeAllowed()==False) Sleep(orderinterval);
   //----
      tries = 0;
      while(tries<timeout){
        ticket = OrderSend(Symbol(),method,Lots,newEntry,Slippage,SL,TP,comment,magic_base,expiration,clr_entry);
        if(ticket>0){ tries = timeout;
                      if(TradeLog==True) Trade_Log(lastType,DoubleToStr(newEntry,precision),lastSigBar);
                      if(TestMode==False) Alert("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+" "+lastType+" "+DoubleToStr(Lots,1)+" Lots @ "+lastPrice);
        }
        else{ tries++;
              Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Cannot send order, error: ",GetLastError());
              Sleep(orderinterval);
        }
      }
 //---- end of "if(action==1){"
      return(0);
    }
//---- 
   return(0);
  }
//+------------------------------------------------------------------+
//| expert SetLots function                                          |
//+------------------------------------------------------------------+
double SetLots()
  {
//----                                           
    int i,factor,pow,total;                         
    double j = 0.0;                      //the idea is to use a fixed % of $ to support every Lot; 
    double Lots = 0.0;                   //e.g. if $20,000 is required for 1 Lot, then
    double ratio = 0.0;                  //     you want to trade 2 Lots, you must have $20,000*2 = $40,000;   
    double TotalRisk = 0.0;              //     you want to trade 30 Lots, you must have $20,000*30 = $600,000;        
    double RealEquity = 0.0;             //     you want to trade 0.4 Lots, you must have $20,000*0.4 = $8,000;
    double tick_value = 0.0;
 //---- set the Lots assuming there is no order in the market;                                            
    ratio = AccountBalance()/CapitalPerLot;
    if(ratio<0.1) Lots = 0.1;         
    else if(ratio>=0.1 && ratio<1){ j = 0.1;                                      
      while(j<1){ if(ratio>=j && ratio<j+0.1){ Lots = j;                                 
                                               j = 1;                                    
                  }                                           
                  else j = j + 0.1;   
      }
    } 
    else if(ratio>=1 && ratio<10){ j = 1;
      while(j<10){ if(ratio>=j && ratio<j+1){ Lots = j;
                                              j = 10;
                   }
                   else j = j + 1;
      }
    }
    else if(ratio>=10 && ratio<100){ j = 10;
      while(j<100){ if(ratio>=j && ratio<j+10){ Lots = j;
                                                j = 100;
                    }
                    else j = j + 10;
      }
    }
    else Lots = 100;
 //---- Modify the Lots if there are open orders in the market     
    total = OrdersTotal();
 //----
    if(total<=0) return(Lots);
    else{ for(i=total;i>=0;i--){
           if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
             tick_value = MarketInfo(OrderSymbol(),MODE_TICKVALUE);
             pow = MarketInfo(OrderSymbol(),MODE_DIGITS);
             factor = MathPow(10,pow);
             if(OrderType()==OP_BUY){ 
               if(OrderStopLoss()==0) TotalRisk = AccountBalance();
               else if(TotalRisk==0)  TotalRisk = (OrderOpenPrice() - OrderStopLoss())*OrderLots()*tick_value*factor;
               else TotalRisk = TotalRisk + (OrderOpenPrice() - OrderStopLoss())*OrderLots()*tick_value*factor;
             }
             if(OrderType()==OP_SELL){
               if(OrderStopLoss()==0) TotalRisk = AccountBalance();
               else if(TotalRisk==0) TotalRisk = (OrderStopLoss() - OrderOpenPrice())*OrderLots()*tick_value*factor;
               else TotalRisk = TotalRisk + (OrderStopLoss() - OrderOpenPrice())*OrderLots()*tick_value*factor;
             }
           }
           //else Print("OrderSelect returned the error of ",GetLastError());     
          }
    } 
 //----
    if(TotalRisk>=AccountBalance()){ 
      if(TestMode==False) Alert("too risky! no more trades allowed!");
      Lots = 0;
      return(Lots);
    }
    else RealEquity = AccountBalance() - TotalRisk;
 //----   
    if(RealEquity>0){ ratio = RealEquity/CapitalPerLot;
      if(ratio<0.1) Lots = 0.1;
      else if(ratio>=0.1 && ratio<1){ j = 0.1;
        while(j<1){ if(ratio>=j && ratio<j+0.1){ Lots = j;
                                                 j = 1;
                    }
                    else j = j + 0.1;
        }
      }
      else if(ratio>=1 && ratio<10){ j = 1;
        while(j<10){ if(ratio>=j && ratio<j+1){ Lots = j;
                                                j = 10;
                     }
                     else j = j + 1;
        }
      }
      else if(ratio>=10 && ratio<100){ j = 10;
        while(j<100){ if(ratio>=j && ratio<j+10){ Lots = j;
                                                  j = 100;
                      }
                      else j = j + 10;
        }
      }
      else Lots = 100;
   //----   
      return(Lots);
    }  
//----
   //Print("total = ",total," AccountBalance = ",AccountBalance()," RealEquity = ",RealEquity," TotalRisk = ",TotalRisk," Lots = ",Lots);
   return(Lots);
  }
//+------------------------------------------------------------------+
//| expert specific function DeletePending()                         |
//+------------------------------------------------------------------+
int DeletePending(string type)
  {
//----
    int i = 0;
    int tries = 0;
    int total = OrdersTotal();
    bool ticket = False;
 //----
    if(type=="long "){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base 
                           && (OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP)){
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderDelete(OrderTicket());
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False)
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Long Pending Order_"+OrderTicket()+" Deleted!");
                            }
                            else{ tries++;
                                  Print("OrderDelete returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
 //----
    if(type=="short"){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base
                           && (OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)){
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderDelete(OrderTicket());
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Short Pending Order_"+OrderTicket()+" Deleted!");
                            }
                            else{ tries++;
                                  Print("OrderDelete returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            } 
                          }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
//----
   return(0);
  }   
//+------------------------------------------------------------------+
//| expert specific function ModifyStopLoss()                        |
//+------------------------------------------------------------------+
int ModifySL(string type,double newSL)
  {
//----
    int i,total,tries;
    bool ticket;
    string TimeNow = TimeToStr(TimeCurrent(),TIME_MINUTES);
 //----
    total = OrdersTotal();
 //----
    if(type=="long "){ for(i=total;i>=0;i--){
                        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
                        if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(newSL>0.0 && (OrderStopLoss()<=0.0 || OrderStopLoss()<newSL)){
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderModify(OrderTicket(),OrderOpenPrice(),newSL,OrderTakeProfit(),0,clr_modify);
                            if(ticket>0){ tries = timeout;
                              //if(MailAlert==True) SendMail("BOLL_"+Symbol()+" SL@"+DoubleToStr(newSL,precision)+"; "+TimeNow," ");
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" SL moved to ",DoubleToStr(newSL,precision),"!");
                            }
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
    if(type=="short"){ for(i=total;i>=0;i--){
                        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
                        if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(newSL>0.0 && (OrderStopLoss()<=0.0 || OrderStopLoss()>newSL)){
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderModify(OrderTicket(),OrderOpenPrice(),newSL,OrderTakeProfit(),0,clr_modify);
                            if(ticket>0){ tries = timeout;
                              //if(MailAlert==True) SendMail("BOLL_"+Symbol()+" SL@"+DoubleToStr(newSL,precision)+"; "+TimeNow," ");
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" SL moved to ",DoubleToStr(newSL,precision),"!");
                            }
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert specific function ModifyBreakEven()                       |
//+------------------------------------------------------------------+
int ModifyBE(string type)
  {
//----
    int i,total,tries;
    bool ticket;
    double BE;
 //----
    total = OrdersTotal();
    if(type=="long "){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(OrderType()==OP_BUY && OrderOpenPrice()<=(Bid-BreakEven*Point) 
                           && (OrderStopLoss()<OrderOpenPrice() || OrderStopLoss()==0)){
                          BE = NormalizeDouble(OrderOpenPrice(),precision);
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderModify(OrderTicket(),0,BE,OrderTakeProfit(),expiration,clr_modify);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" Break Even @ ",DoubleToStr(BE,precision),"!");
                            }
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }  
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }  
    if(type=="short"){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(OrderType()==OP_SELL && OrderOpenPrice()>=(Ask+BreakEven*Point) 
                           && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0)){
                          BE = NormalizeDouble(OrderOpenPrice(),precision);
                          tries = 0;
                          while(tries<timeout){ 
                            ticket = OrderModify(OrderTicket(),0,BE,OrderTakeProfit(),expiration,clr_modify);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" Break Even @ ",DoubleToStr(BE,precision),"!");
                            }     
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }       
                        }      
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert specific utility function ClosePositions                  |
//+------------------------------------------------------------------+
int ClosePositions(string type)
  {
//----
    int i,total,tries;
    bool ticket;
    double longExit,shortExit;
 //----
    total = OrdersTotal();
 //---- modify existing long order if a new short signal is given
    if(type=="long "){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base && OrderType()==OP_BUY){
                          longExit = NormalizeDouble(Bid,precision);
                          tries = 0;
                          while(tries<timeout){
                            ticket = OrderClose(OrderTicket(),OrderLots(),longExit,Slippage,clr_close);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+" Long Position closed @ ",longExit,"!");
                            }
                            else{ tries++;
                                  Print("OrderClose returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
    if(type=="short"){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base && OrderType()==OP_SELL){
                          shortExit = NormalizeDouble(Ask,precision);
                          tries = 0;
                          while(tries<timeout){
                            ticket = OrderClose(OrderTicket(),OrderLots(),shortExit,Slippage,clr_close);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+" Short Position closed @ ",shortExit,"!");
                            }
                            else{ tries++;
                                  Print("OrderClose returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
//----
   return(0);
  }   
//+------------------------------------------------------------------+
//| expert specific function ModifyTrailingStop()                    |
//+------------------------------------------------------------------+
int ModifyTS(string type)
  {
//----
    int i,total,tries;
    bool ticket;
    double TS;
 //----
    total = OrdersTotal();
 //----
    if(type=="long "){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(OrderType()==OP_BUY && (OrderStopLoss()<(Bid-TrailingStop*Point) || OrderStopLoss()==0.0)){
                          TS = NormalizeDouble(Bid-TrailingStop*Point,precision);
                          tries = 0;
                          while(tries<timeout){
                            ticket = OrderModify(OrderTicket(),0,TS,OrderTakeProfit(),expiration,clr_modify);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" Trailing Stop Activated");
                            }
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
    if(type=="short"){ for(i=total;i>=0;i--){
                        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic_base){
                        if(OrderType()==OP_SELL && (OrderStopLoss()>(Ask+TrailingStop*Point) || OrderStopLoss()==0.0)){
                          TS = NormalizeDouble(Ask+TrailingStop*Point,precision);
                          tries = 0;
                          while(tries<timeout){
                            ticket = OrderModify(OrderTicket(),0,TS,OrderTakeProfit(),expiration,clr_modify);
                            if(ticket>0){ tries = timeout;
                              if(TestMode==False) 
                                Print("myBOLL_"+BOLL+" "+Symbol()+"_"+Period()+"; Order_"+OrderTicket()+" Trailing Stop Activated");
                            }
                            else{ tries++;
                                  Print("OrderModify returned the error of ",GetLastError());
                                  Sleep(orderinterval);
                            }
                          }
                        }
                        }
                        }
                        //else Print("OrderSelect returned the error of ",GetLastError());     
                       }
                       return(0);
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+