//*
//* MAs
//*
//* 2006/12/13 version 1.0
//*
#property copyright "Midnite Corp."
#property link "http://www.midnite.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

//---- input parameters
extern int BOLL = 5;
extern int Filter = 10;
extern bool TradeLog = True;

//---- buffers
int Spread = 4;
int precision = 4;
double MA_FAST[];
double MA_SLOW[];
//----
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Spread = MarketInfo(Symbol(),MODE_SPREAD);
   precision = MarketInfo(Symbol(),MODE_DIGITS);
//----
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(0,MA_FAST);
   SetIndexDrawBegin(0,BOLL-1);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexBuffer(1,MA_SLOW);
   SetIndexDrawBegin(1,BOLL*3-1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Log the Trade                                                    |
//+------------------------------------------------------------------+
void Trade_Log(string type,string price,string sigBar)
  {
//---- 
   string log = type+"@"+price+" @ "+sigBar+" Bars"+" @ "+TimeToStr(CurTime(),TIME_DATE|TIME_MINUTES);
   int handle = FileOpen("BOLL_"+BOLL+"_"+Symbol()+"_"+Period()+"_lastSignal.dat",FILE_BIN|FILE_READ|FILE_WRITE);
   if(handle>0){ FileWrite(handle,log);
                 FileClose(handle);
                 handle = 0; 
   } 
//----
  }
//+------------------------------------------------------------------+
//| BOLL                                                      |
//+------------------------------------------------------------------+
int start()
  {
//----
   int i,prevBars;
   string sigBar = "";
   string newEntry = "";
   static bool GoLong = False;
   static bool GoShort = False;
//----
   if(Bars<=BOLL) return(0);
//---- zero initial bars
   int counted_bars = IndicatorCounted();
//----  
   if(counted_bars<1){ 
     for(i=1;i<=BOLL;i++){ 
       MA_FAST[Bars-i] = 0;
       MA_SLOW[Bars-i] = 0;
     }
   }
//---- 
   int lastbar = Bars - counted_bars - 1;
   lastbar = MathMin(Bars-BOLL,lastbar);
//---- main calculation loop
   for(i=lastbar;i>=0;i--){
     MA_FAST[i] = iMA(NULL,0,BOLL,0,1,0,i);
     MA_SLOW[i] = iMA(NULL,0,BOLL*3,0,1,0,i);
   }
//---- Markers & Arrows  
   for(i=lastbar;i>=0;i--){
     prevBars = Bars - i;  //the No. of bars before the signal bar;
  //---- limiting the length of the string var sigBar to 7 chars;
     if(prevBars<100) sigBar = "0000000";
     if(prevBars>=100 && prevBars<1000) sigBar = prevBars+"    ";
     else if(prevBars>=1000 && prevBars<10000) sigBar = prevBars+"   ";
     else if(prevBars>=10000 && prevBars<100000) sigBar = prevBars+"  ";
     else if(prevBars>=100000 && prevBars<1000000) sigBar = prevBars+" ";
     else if(prevBars>=1000000 && prevBars<10000000) sigBar = prevBars;
     else sigBar = "9999999";
  //---- record the value if lower channel line drops
     if(GoLong==True){
     }
  //---- mark long signals
     else if(MA_FAST[i+1]>MA_SLOW[i+1]){ 
       GoLong = True;
       GoShort = False;
       newEntry = DoubleToStr(High[i+1]+(Filter+Spread)*Point,precision);
       if(TradeLog==True) Trade_Log("long ",newEntry,sigBar);
     }
  //---- record the value if upper channel line rises
     if(GoShort==True){ 
     }
  //---- mark short signals
     else if(MA_FAST[i+1]<MA_SLOW[i+1]){ 
       GoLong = False;
       GoShort = True;
       newEntry = DoubleToStr(Low[i+1]-Filter*Point,precision);
       if(TradeLog==True) Trade_Log("short",newEntry,sigBar);
     }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+